package com.gbasedbt.springboothibernategbase8s;

import com.gbasedbt.springboothibernategbase8s.pojo.User;
import com.gbasedbt.springboothibernategbase8s.service.UserService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import java.util.Optional;

@Controller
public class UserController {

    @Autowired
    private UserService userService;

    @RequestMapping("/save")
    @ResponseBody
    public String saveUser() {
        User user = new User();
        user.setName("测试用户");
        user.setPassword("123457");
        user.setEmail("testuser@gbasedbt.com");

        userService.addUser(user);
        return "保存用户成功";
    }

    @RequestMapping("/find/{id}")
    @ResponseBody
    public Optional<User> findUser(@PathVariable Integer id) {

        return userService.findUserById(id);
    }

    @RequestMapping("/del/{id}")
    @ResponseBody
    public String delUser(@PathVariable Integer id) {

        userService.delUser(id);
        return "删除用户成功";
    }

    @RequestMapping("/page/{size}/{page}")
    @ResponseBody
    public Page<User> findUserByPage(@PathVariable Integer page, @PathVariable Integer size){
        return userService.getUserWithPage(page, size);
    }
}
