package com.gbasedbt.springboothibernategbase8s.serviceimpl;

import com.gbasedbt.springboothibernategbase8s.dao.UserDao;
import com.gbasedbt.springboothibernategbase8s.pojo.User;
import com.gbasedbt.springboothibernategbase8s.service.UserService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Pageable;
import org.springframework.stereotype.Service;

import java.util.Optional;

@Service
public class UserServiceImpl implements UserService {

    @Autowired
    private UserDao userDao;

    @Override
    public void addUser(User user) {

        userDao.save(user);
    }

    public Optional<User> findUserById(Integer id) {
        return userDao.findById(id);
    }

    public void delUser(Integer id) {
        userDao.deleteById(id);
    }

    @Override
    public Page<User> getUserWithPage(Integer page, Integer size) {
        if (page < 1){
            page = 1;
        }
        Pageable pageRequest = PageRequest.of(page - 1, size);
        return userDao.findAll(pageRequest);
    }
}
